{$IFDEF NOPE}
program OpticnaMiska;
const cxMax = 16; cyMax = 16;
type SlikaT = array [0..cyMax - 1, 0..cxMax - 1] of integer;
var 
  cx, cy, dx, dy, dxNaj, dyNaj, dxMax, dyMax, nSlik, si, x, y: integer;
  OcenaA, OcenaB, NajA, NajB: integer;
  S, SP: SlikaT; 
begin
  Read(cx, cy, dxMax, dyMax, nSlik);
  for si := 1 to nSlik do begin
    if si > 1 then SP := S;
    for y := 0 to cy - 1 do for x := 0 to cx - 1 do Read(S[y, x]);
    if si = 1 then continue;
    NajA := -1; NajB := -1;
    for dy := -dyMax to dyMax do for dx := -dxMax to dxMax do begin
      OcenaA := 0; OcenaB := 0;
      y := -dy; if y < 0 then y := 0;
      while (y < cy) and (y - dy < cy) do begin
        x := -dx; if x < 0 then x := 0;
        while (x < cx) and (x - dx < cx) do begin
          OcenaA := OcenaA + Abs(SP[y, x] - S[y - dy, x - dx]);
          OcenaB := OcenaB + 1; x := x + 1;
        end; {while x}
        y := y + 1;
      end; {while y}
      if (NajB < 0) or (OcenaA * NajB > OcenaB * NajA) then
        begin NajA := OcenaA; NajB := OcenaB; dxNaj := dx; dyNaj := dy end;
    end; {for dx, dy}
    WriteLn(dxNaj, ' ', dyNaj);
  end; {for si}
end. {OpticnaMiska}
{$ENDIF}

{$IFDEF NOPE}
{ Ta razliica predpostavi, da sta v vhodni datoteki le dve sliki. }
program OpticnaMiska;
const cxMax = 64; cyMax = 64; dxMax = 3; dyMax = 3;
var 
  cx, cy, dx, dy, dxNaj, dyNaj, x, y: integer;
  OcenaA, OcenaB, NajA, NajB, nNaj: integer;
  SP, SN: array [0..cyMax - 1, 0..cxMax - 1] of integer;
  T: text;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'miska.in');
  Reset(T); Read(T, cx); Assert(4 <= cx); Assert(cx <= cxMax); cy := cx;
  for y := 0 to cy - 1 do 
    begin for x := 0 to cx - 1 do Read(T, SP[y, x]);  ReadLn(T) end;
  for y := 0 to cy - 1 do 
    begin for x := 0 to cx - 1 do Read(T, SN[y, x]);  ReadLn(T) end;
  Close(T);
  NajA := -1; NajB := -1;
  nNaj := 0;
  for dy := -dyMax to dyMax do for dx := -dxMax to dxMax do begin
    OcenaA := 0; OcenaB := 0;
    y := dy; if y < 0 then y := 0;
    while (y < cy) and (y - dy < cy) do begin
      x := dx; if x < 0 then x := 0;
      while (x < cx) and (x - dx < cx) do begin
      	{WriteLn(x, ' ', y, ' ', x - dx, ' ', y - dy);}
        OcenaA := OcenaA + Abs(SP[y, x] - SN[y - dy, x - dx]);
        OcenaB := OcenaB + 1; x := x + 1;
      end; {while x}
      y := y + 1;
    end; {while y}
    {Write((OcenaA / OcenaB):6:3, ' '); if dx = dxMax then WriteLn;}
    if (nNaj > 0) and (OcenaA * NajB = OcenaB * NajA) then nNaj := nNaj + 1;
    if (NajB < 0) or (OcenaA * NajB < OcenaB * NajA) then
      begin NajA := OcenaA; NajB := OcenaB; dxNaj := dx; dyNaj := dy; nNaj := 1 end;
  end; {for dx, dy}
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'miska.out');
  Rewrite(T); WriteLn(T, dxNaj, ' ', dyNaj); 
  Assert(nNaj = 1); if nNaj <> 1 then WriteLn(T, '#### ', nNaj);
  Close(T);
end. {OpticnaMiska}
{$ENDIF}

program OpticnaMiska;
const cxMax = 64; cyMax = 64; dxMax = 3; dyMax = 3;
var 
  cx, cy, dx, dy, dxNaj, dyNaj, x, y: integer;
  OcenaA, OcenaB, NajA, NajB, nNaj, i, StPrimerov: integer;
  SP, SN: array [0..cyMax - 1, 0..cxMax - 1] of integer;
  T, U: text;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'miska.in');
  Reset(T); ReadLn(T, StPrimerov); Assert(1 <= StPrimerov); Assert(StPrimerov <= 30);
  if ParamCount > 1 then Assign(U, ParamStr(2)) else Assign(U, 'miska.out');
  Rewrite(U); 
  while StPrimerov > 0 do begin
    ReadLn(T); StPrimerov := StPrimerov - 1;
    Read(T, cx); Assert(4 <= cx); Assert(cx <= cxMax); cy := cx;
    { Preberimo obe sliki. }
    ReadLn(T); for y := 0 to cy - 1 do 
      begin for x := 0 to cx - 1 do Read(T, SP[y, x]);  ReadLn(T) end;
    ReadLn(T); for y := 0 to cy - 1 do 
      begin for x := 0 to cx - 1 do Read(T, SN[y, x]);  ReadLn(T) end;
    { Primerjajmo sliki in doloimo premik. }
    NajA := -1; NajB := -1;
    nNaj := 0;
    for dy := -dyMax to dyMax do for dx := -dxMax to dxMax do begin
      OcenaA := 0; OcenaB := 0;
      y := dy; if y < 0 then y := 0;
      while (y < cy) and (y - dy < cy) do begin
        x := dx; if x < 0 then x := 0;
        while (x < cx) and (x - dx < cx) do begin
          OcenaA := OcenaA + Abs(SP[y, x] - SN[y - dy, x - dx]);
          OcenaB := OcenaB + 1; x := x + 1;
        end; {while x}
        y := y + 1;
      end; {while y}
      {Write((OcenaA / OcenaB):6:3, ' '); if dx = dxMax then WriteLn;}
      {Write(OcenaA, '/', OcenaB, ' '); if dx = dxMax then WriteLn;}
      if (nNaj > 0) and (OcenaA * NajB = OcenaB * NajA) then nNaj := nNaj + 1;
      if (NajB < 0) or (OcenaA * NajB < OcenaB * NajA) then
        begin NajA := OcenaA; NajB := OcenaB; dxNaj := dx; dyNaj := dy; nNaj := 1 end;
    end; {for dx, dy}
    WriteLn(U, dxNaj, ' ', dyNaj); 
    Assert(nNaj = 1); if nNaj <> 1 then WriteLn(U, '#### ', nNaj);
  end; {while}
  Close(T); Close(U);
end. {OpticnaMiska}
