program SpletneKnjigarne;
const MaxK = 10; MaxN = 10000; MaxCena = 10000;
var
  Ai, Bi: array [1..MaxK] of integer;
  Cij: array [1..MaxK, 1..MaxN] of integer;
  Cj: array [1..MaxN] of integer;
  i, j, k, n, Ks, Cena, NajCena: integer;
  T: text;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'knjigarne.in');
  Reset(T); ReadLn(T, n, k);
  for i := 1 to k do begin Read(T, Ai[i]); Assert(1 <= Ai[i]); Assert(Ai[i] <= MaxCena); end;
  ReadLn(T);
  for i := 1 to k do begin Read(T, Bi[i]); Assert(1 <= Bi[i]); Assert(Bi[i] <= Ai[i]); end;
  ReadLn(T);
  for j := 1 to n do begin
    for i := 1 to k do begin Read(T, Cij[i, j]); Assert(1 <= Cij[i, j]); Assert(Cij[i, j] <= MaxCena); end;
    ReadLn(T);
  end; {for j}
  { }
  NajCena := (MaxCena + 1) * (n + n + k);
  for Ks := 0 to (1 shl k) - 1 do begin
    Cena := 0;
    for j := 1 to n do Cj[j] := 2 * MaxCena + 1;
    for i := 1 to k do if (Ks and (1 shl (i - 1))) <> 0 then begin
      Cena := Cena + Ai[i] - Bi[i];
      for j := 1 to n do if Cj[j] > Bi[i] + Cij[i, j] then 
        Cj[j] := Bi[i] + Cij[i, j];
    end; {for i}
    for j := 1 to n do Cena := Cena + Cj[j];
    if Cena < NajCena then NajCena := Cena;
  end; {for Ks}
  { }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'knjigarne.out');
  Rewrite(T); WriteLn(T, NajCena); Close(T);
end. {SpletneKnjigarne}